module clockdivider
#(
  parameter max_count = 12499
)
(
  input  clk,
  output clk_slow
);

// f_slow_clk = f_clk / (2 * (max_count+1))

// Setzen des Startwerts mit dieser Syntax wird vom Xilinx-Synthesewerkzeug untersttzt:
// siehe http://www.xilinx.com/itp/xilinx10/books/docs/sim/sim.pdf, S.75
reg [31:0] count = 32'd0;
reg clk_slow_reg = 1'b0;
assign clk_slow = clk_slow_reg;

always @(posedge clk) begin
  if (count == max_count) begin
    count <= 32'd0;
    clk_slow_reg <= ~clk_slow_reg;
  end else begin
    count <= count + 32'd1;
  end
end

endmodule

