module count_en_FSM
(
    input clk,
    input start,
    input stopp,
    output count_en
);

reg current_state, next_state;

parameter st_idle     = 1'b0;
parameter st_counting = 1'b1;

assign count_en = current_state;

wire [1:0] inputvector = {start, stopp};

always @(*) begin
    casex({inputvector, current_state})
        {2'b0x, st_idle}: next_state = st_idle;
        {2'b1x, st_idle}: next_state = st_counting;
        
        {2'bx0, st_counting}: next_state = st_counting;
        {2'bx1, st_counting}: next_state = st_idle;

        default: next_state = st_idle;
    endcase
end

always @(posedge clk) begin
    current_state <= next_state;
end

endmodule

