module counter_digit
#(
    parameter max_count = 16
)
(
    input clk,
    input reset,
    input enable,
    output enable_out,
    output reg [3:0] count
);

always @(posedge clk or posedge reset) begin
    if (reset == 1'b1)
        count <= 4'd0;
    else if (enable == 1'b1) begin
        if (count == max_count)
            count <= 4'd0;
        else
            count <= count + 4'd1;
    end
end

assign enable_out = enable && (count == max_count);

endmodule

