module entprell_alle
#(
    parameter max_count = 25000
)
(
    input clk,
    input [3:0] taste,
    output [3:0] taste_entprellt,
    output [3:0] taste_posedge,
    output [3:0] taste_negedge
);

genvar i;
generate for (i=0; i<4; i=i+1)
    begin: entprell_loop
        entpreller #(.max_count(max_count)) entprell_inst
        (
            .clk(clk),
            .taste_in(taste[i]),
            .taste_entprellt(taste_entprellt[i])
        );
        edgedetector det_pos
        (
            .clk(clk),
            .signal(taste_entprellt[i]),
            .signal_posedge(taste_posedge[i])
        );
        edgedetector det_neg
        (
            .clk(clk),
            .signal(~taste_entprellt[i]),
            .signal_posedge(taste_negedge[i])
        );
    end
endgenerate

endmodule

