module siebensegment_dekoder
(
    input [4:0] code, // 4 Bit + Dezimalpunkt
    output [7:0] segmente // 7 Segmente + Dezimalpunkt
);

//                  AAA
// segmente sind   F   B
// active low!     F   B
//                  GGG
//                 E   C
//                 E   C
//                  DDD
//                                    GFEDCBA
                                             
assign segmente = (code[4:1] == 4'd0  ? {7'b1000000, ~code[0]} :
                  (code[4:1] == 4'd1  ? {7'b1111001, ~code[0]} :
                  (code[4:1] == 4'd2  ? {7'b0100100, ~code[0]} :
                  (code[4:1] == 4'd3  ? {7'b0110000, ~code[0]} :
                  (code[4:1] == 4'd4  ? {7'b0011001, ~code[0]} :
                  (code[4:1] == 4'd5  ? {7'b0010010, ~code[0]} :
                  (code[4:1] == 4'd6  ? {7'b0000010, ~code[0]} :
                  (code[4:1] == 4'd7  ? {7'b1111000, ~code[0]} :
                  (code[4:1] == 4'd8  ? {7'b0000000, ~code[0]} :
                  (code[4:1] == 4'd9  ? {7'b0010000, ~code[0]} :
                  (code[4:1] == 4'd10 ? {7'b0001000, ~code[0]} :
                  (code[4:1] == 4'd11 ? {7'b0000011, ~code[0]} :
                  (code[4:1] == 4'd12 ? {7'b1000110, ~code[0]} :
                  (code[4:1] == 4'd13 ? {7'b0100001, ~code[0]} :
                  (code[4:1] == 4'd14 ? {7'b0000110, ~code[0]} :
                  (code[4:1] == 4'd15 ? {7'b0001110, ~code[0]} :
                   8'bzzzzzzzz ))))))))))))))));

endmodule

