module update_display_FSM
(
    input clk,
    input zwischenzeit,
    input null,
    input count_en,
    output update_display
);

reg current_state, next_state;

parameter st_update = 1'b1;
parameter st_pause  = 1'b0;

assign update_display = current_state;

wire [2:0] inputvector = {zwischenzeit, null, count_en};

always @(*) begin
    casex({inputvector, current_state})
        {3'b0xx, st_update}: next_state = st_update;
        {3'b1xx, st_update}: next_state = st_pause;
        
        {3'b001, st_pause}: next_state = st_pause;
        {3'b1xx, st_pause}: next_state = st_update;
        {3'bx1x, st_pause}: next_state = st_update;
        {3'bxx0, st_pause}: next_state = st_update;

        default: next_state = st_update;
    endcase
end

always @(posedge clk) begin
    current_state <= next_state;
end

endmodule
